<template>
  <div>
    <h1 class="text-2xl text-red-400">{{ title }}</h1>
    <table class="table-auto border-separate border border-green-800">
      <tr
        class="
          text-md
          font-semibold
          tracking-wide
          text-left text-gray-900
          bg-gray-100
          uppercase
          border-b border-gray-600
        "
      >
        <th>Nombre completo</th>
        <th>cargos</th>
        <th>sucursales</th>
        <th>horas/semana</th>
      </tr>
      <tr
        v-for="user in usersList"
        :key="user.employeeId"
        class="text-gray-700"
      >
        <td class="px-4 py-3 border">
          {{ user.firstName }} {{ user.lastName }}
        </td>
        <td class="px-4 py-3 border">{{ user.email }}</td>
        <td class="px-4 py-3 border">{{ user.locationName }}</td>
        <td class="px-4 py-3 border">{{ user.legalMaxWeeklyHours }}</td>
      </tr>
    </table>
    <ul v-if="errors && errors.length">
      <li v-for="error of errors" :key="error.message">
        {{ error.message }}
      </li>
    </ul>
  </div>
</template>

<script>
import getUsers from '../helpers/getUsers.js';
import getLocations from '../helpers/getLocations.js';
import getContracts from '../helpers/getContracts.js';
export default {
  data() {
    return {
      title: 'Vista de Usuarios',
      usersList: [],
      errors: [],
    };
  },
  async created() {
    try {
      this.usersList = await getUsers();
      this.locationsList = await getLocations();
      this.contractsList = await getContracts();
      this.usersList.sort(function (a, b) {
        if (a.employeeId > b.employeeId) {
          return 1;
        }
        if (a.employeeId < b.employeeId) {
          return -1;
        }
        return 0;
      });
      const locationList = this.locationsList;
      const contractList = this.contractsList;
      this.usersList.forEach(async function (user) {
        const location = locationList.find((loc) => user.locationId == loc.id);
        user.locationName = location.name;
        const contract = contractList.find(
          (contract) => user.contract == contract.id
        );
        user.legalMaxWeeklyHours = contract.legalMaxWeeklyHours;
      });
    } catch (e) {
      this.errors.push(e);
    }
  },
};
</script>
